common: replace chattr with $CHATTR_PROG
[xfstests-dev.git] / tests / xfs / 085
1 #! /bin/bash
2 # FS QA Test No. 085
3 #
4 # Create and populate an XFS filesystem, corrupt a superblock, then see how
5 # the kernel and xfs_repair deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44 . ./common/populate
45
46 # real QA test starts here
47 _supported_fs xfs
48 _supported_os Linux
49
50 _require_scratch
51 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
52 _require_attrs
53 _require_xfs_db_blocktrash_z_command
54
55 rm -f $seqres.full
56 TESTDIR="${SCRATCH_MNT}/scratchdir"
57 TESTFILE="${TESTDIR}/testfile"
58
59 echo "+ create scratch fs"
60 _scratch_mkfs_xfs > /dev/null
61
62 echo "+ mount fs image"
63 _scratch_mount
64 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
65
66 echo "+ make some files"
67 mkdir -p "${TESTDIR}"
68 for x in `seq 1 1024`; do
69         touch "${SCRATCH_MNT}/junk.${x}"
70         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
71         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
72                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
73                 break
74         fi
75 done
76 for x in `seq 2 64`; do
77         touch "${TESTFILE}.${x}"
78 done
79 inode="$(stat -c '%i' "${TESTFILE}.1")"
80 agcount="$(xfs_info "${SCRATCH_MNT}" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g')"
81 umount "${SCRATCH_MNT}"
82
83 echo "+ check fs"
84 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
85
86 echo "+ corrupt image"
87 $XFS_IO_PROG -f -c "pwrite -S 0x62 32 4" "${SCRATCH_DEV}" >> $seqres.full
88
89 echo "+ mount image"
90 _scratch_mount 2>/dev/null && _fail "mount should not succeed"
91
92 echo "+ repair fs"
93 _scratch_xfs_repair >> $seqres.full 2>&1
94
95 echo "+ mount image (2)"
96 _scratch_mount
97
98 echo "+ chattr -R -i"
99 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
100
101 echo "+ modify files (2)"
102 broken=0
103 for x in `seq 1 64`; do
104         test -e "${TESTFILE}.${x}" || continue
105         echo moo | dd oflag=append conv=notrunc of="${TESTFILE}.${x}" 2>/dev/null
106         test $? -ne 0 && broken=1
107 done
108 echo "broken: ${broken}"
109 umount "${SCRATCH_MNT}"
110
111 echo "+ check fs (2)"
112 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
113
114 status=0
115 exit